Index: LMDZ5/trunk/DefLists/field_def_lmdz.xml
===================================================================
--- LMDZ5/trunk/DefLists/field_def_lmdz.xml	(revision 2484)
+++ LMDZ5/trunk/DefLists/field_def_lmdz.xml	(revision 2487)
@@ -391,4 +391,15 @@
         <field id="rsutcs4co2"    long_name="TOA Out CS SW in 4xCO2 atmosphere"    unit="W/m2" />
         <field id="rlutcs4co2"    long_name="TOA Out CS LW in 4xCO2 atmosphere"    unit="W/m2" />
+        <field id="dqphy2d"    long_name="Physics dQ"    unit="(kg/m2)/s" />
+        <field id="dqdyn2d"    long_name="Dynamics dQ"    unit="(kg/m2)/s" />
+        <field id="dqcon2d"    long_name="Convection dQ"    unit="(kg/m2)/s" />
+        <field id="dqwak2d"    long_name="Wake dQ"    unit="(kg/m2)/s" />
+        <field id="dqlsc2d"    long_name="Condensation dQ"    unit="(kg/m2)/s" />
+        <field id="dqvdf2d"    long_name="Boundary-layer dQ"    unit="(kg/m2)/s" />
+        <field id="dqeva2d"    long_name="Reevaporation dQ"    unit="(kg/m2)/s" />
+        <field id="dqlscth2d"    long_name="dQ therm."    unit="(kg/m2)/s" />
+        <field id="dqlscst2d"    long_name="dQ strat."    unit="(kg/m2)/s" />
+        <field id="dqthe2d"    long_name="Thermal dQ"    unit="(kg/m2)/s" />
+        <field id="dqajs2d"    long_name="Dry ajdust dQ"    unit="(kg/m2)/s" />
     </field_group>
 
Index: LMDZ5/trunk/DefLists/file_def_histLES_lmdz.xml
===================================================================
--- LMDZ5/trunk/DefLists/file_def_histLES_lmdz.xml	(revision 2484)
+++ LMDZ5/trunk/DefLists/file_def_histLES_lmdz.xml	(revision 2487)
@@ -382,4 +382,15 @@
                 <field field_ref="rsutcs4co2" level="10" />
                 <field field_ref="rlutcs4co2" level="10" />
+                <field field_ref="dqphy2d" level="10" />
+                <field field_ref="dqdyn2d" level="10" />
+                <field field_ref="dqcon2d" level="10" />
+                <field field_ref="dqwak2d" level="10" />
+                <field field_ref="dqlsc2d" level="10" />
+                <field field_ref="dqvdf2d" level="10" />
+                <field field_ref="dqeva2d" level="10" />
+                <field field_ref="dqlscth2d" level="10" />
+                <field field_ref="dqlscst2d" level="10" />
+                <field field_ref="dqthe2d" level="10" />
+                <field field_ref="dqajs2d" level="10" />
             </field_group>
 
Index: LMDZ5/trunk/DefLists/file_def_histday_lmdz.xml
===================================================================
--- LMDZ5/trunk/DefLists/file_def_histday_lmdz.xml	(revision 2484)
+++ LMDZ5/trunk/DefLists/file_def_histday_lmdz.xml	(revision 2487)
@@ -382,4 +382,15 @@
                 <field field_ref="rsutcs4co2" level="10" />
                 <field field_ref="rlutcs4co2" level="10" />
+                <field field_ref="dqphy2d" level="10" />
+                <field field_ref="dqdyn2d" level="10" />
+                <field field_ref="dqcon2d" level="10" />
+                <field field_ref="dqwak2d" level="10" />
+                <field field_ref="dqlsc2d" level="10" />
+                <field field_ref="dqvdf2d" level="10" />
+                <field field_ref="dqeva2d" level="10" />
+                <field field_ref="dqlscth2d" level="10" />
+                <field field_ref="dqlscst2d" level="10" />
+                <field field_ref="dqthe2d" level="10" />
+                <field field_ref="dqajs2d" level="10" />
             </field_group>
 
Index: LMDZ5/trunk/DefLists/file_def_histhf_lmdz.xml
===================================================================
--- LMDZ5/trunk/DefLists/file_def_histhf_lmdz.xml	(revision 2484)
+++ LMDZ5/trunk/DefLists/file_def_histhf_lmdz.xml	(revision 2487)
@@ -382,4 +382,15 @@
                 <field field_ref="rsutcs4co2" level="10" />
                 <field field_ref="rlutcs4co2" level="10" />
+                <field field_ref="dqphy2d" level="10" />
+                <field field_ref="dqdyn2d" level="10" />
+                <field field_ref="dqcon2d" level="10" />
+                <field field_ref="dqwak2d" level="10" />
+                <field field_ref="dqlsc2d" level="10" />
+                <field field_ref="dqvdf2d" level="10" />
+                <field field_ref="dqeva2d" level="10" />
+                <field field_ref="dqlscth2d" level="10" />
+                <field field_ref="dqlscst2d" level="10" />
+                <field field_ref="dqthe2d" level="10" />
+                <field field_ref="dqajs2d" level="10" />
             </field_group>
 
Index: LMDZ5/trunk/DefLists/file_def_histins_lmdz.xml
===================================================================
--- LMDZ5/trunk/DefLists/file_def_histins_lmdz.xml	(revision 2484)
+++ LMDZ5/trunk/DefLists/file_def_histins_lmdz.xml	(revision 2487)
@@ -382,4 +382,15 @@
                 <field field_ref="rsutcs4co2" level="10" />
                 <field field_ref="rlutcs4co2" level="10" />
+                <field field_ref="dqphy2d" level="10" />
+                <field field_ref="dqdyn2d" level="10" />
+                <field field_ref="dqcon2d" level="10" />
+                <field field_ref="dqwak2d" level="10" />
+                <field field_ref="dqlsc2d" level="10" />
+                <field field_ref="dqvdf2d" level="10" />
+                <field field_ref="dqeva2d" level="10" />
+                <field field_ref="dqlscth2d" level="10" />
+                <field field_ref="dqlscst2d" level="10" />
+                <field field_ref="dqthe2d" level="10" />
+                <field field_ref="dqajs2d" level="10" />
             </field_group>
 
Index: LMDZ5/trunk/DefLists/file_def_histmth_lmdz.xml
===================================================================
--- LMDZ5/trunk/DefLists/file_def_histmth_lmdz.xml	(revision 2484)
+++ LMDZ5/trunk/DefLists/file_def_histmth_lmdz.xml	(revision 2487)
@@ -382,4 +382,15 @@
                 <field field_ref="rsutcs4co2" level="5" />
                 <field field_ref="rlutcs4co2" level="5" />
+                <field field_ref="dqphy2d" level="2" />
+                <field field_ref="dqdyn2d" level="4" />
+                <field field_ref="dqcon2d" level="4" />
+                <field field_ref="dqwak2d" level="4" />
+                <field field_ref="dqlsc2d" level="4" />
+                <field field_ref="dqvdf2d" level="4" />
+                <field field_ref="dqeva2d" level="4" />
+                <field field_ref="dqlscth2d" level="10" />
+                <field field_ref="dqlscst2d" level="10" />
+                <field field_ref="dqthe2d" level="4" />
+                <field field_ref="dqajs2d" level="4" />
             </field_group>
 
Index: LMDZ5/trunk/DefLists/file_def_histstn_lmdz.xml
===================================================================
--- LMDZ5/trunk/DefLists/file_def_histstn_lmdz.xml	(revision 2484)
+++ LMDZ5/trunk/DefLists/file_def_histstn_lmdz.xml	(revision 2487)
@@ -382,4 +382,15 @@
                 <field field_ref="rsutcs4co2" level="10" />
                 <field field_ref="rlutcs4co2" level="10" />
+                <field field_ref="dqphy2d" level="10" />
+                <field field_ref="dqdyn2d" level="10" />
+                <field field_ref="dqcon2d" level="10" />
+                <field field_ref="dqwak2d" level="10" />
+                <field field_ref="dqlsc2d" level="10" />
+                <field field_ref="dqvdf2d" level="10" />
+                <field field_ref="dqeva2d" level="10" />
+                <field field_ref="dqlscth2d" level="10" />
+                <field field_ref="dqlscst2d" level="10" />
+                <field field_ref="dqthe2d" level="10" />
+                <field field_ref="dqajs2d" level="10" />
             </field_group>
 