Index: LMDZ5/trunk/libf/phylmd/cpl_mod.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/cpl_mod.F90	(revision 2541)
+++ LMDZ5/trunk/libf/phylmd/cpl_mod.F90	(revision 2545)
@@ -52,6 +52,4 @@
   REAL, ALLOCATABLE, DIMENSION(:,:), SAVE   :: cpl_windsp
   !$OMP THREADPRIVATE(cpl_windsp)
-  REAL, ALLOCATABLE, DIMENSION(:,:), SAVE   :: cpl_sens_rain, cpl_sens_snow
-  !$OMP THREADPRIVATE(cpl_sens_rain, cpl_sens_snow)
   REAL, ALLOCATABLE, DIMENSION(:,:), SAVE   :: cpl_taumod
   !$OMP THREADPRIVATE(cpl_taumod)
@@ -92,6 +90,4 @@
   REAL, ALLOCATABLE, DIMENSION(:,:), SAVE   :: cpl_windsp2D
   !$OMP THREADPRIVATE(cpl_windsp2D)
-  REAL, ALLOCATABLE, DIMENSION(:,:,:), SAVE   :: cpl_sens_rain2D, cpl_sens_snow2D
-  !$OMP THREADPRIVATE(cpl_sens_rain2D, cpl_sens_snow2D)
   REAL, ALLOCATABLE, DIMENSION(:,:), SAVE   :: cpl_atm_co22D
   !$OMP THREADPRIVATE(cpl_atm_co22D)
@@ -172,7 +168,5 @@
     ALLOCATE(cpl_windsp(klon,2), stat = error)
     sum_error = sum_error + error
-    ALLOCATE(cpl_sens_rain(klon,2), stat = error)
-    sum_error = sum_error + error
-    ALLOCATE(cpl_sens_snow(klon,2), stat = error)
+    ALLOCATE(cpl_taumod(klon,2), stat = error)
     sum_error = sum_error + error
     ALLOCATE(cpl_rriv2D(nbp_lon,jj_nb), stat=error)
@@ -537,6 +531,5 @@
   SUBROUTINE cpl_send_ocean_fields(itime, knon, knindex, &
        swdown, lwdown, fluxlat, fluxsens, &
-       precip_rain, precip_snow, evap, tsurf, fder, albsol, taux, tauy, windsp,&
-       sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol)
+       precip_rain, precip_snow, evap, tsurf, fder, albsol, taux, tauy, windsp)
 !
 ! This subroutine cumulates some fields for each time-step during a coupling 
@@ -559,6 +552,4 @@
     REAL, DIMENSION(klon), INTENT(IN)       :: evap, tsurf, fder, albsol
     REAL, DIMENSION(klon), INTENT(IN)       :: taux, tauy, windsp
-    REAL, DIMENSION(klon), INTENT(IN)       :: sens_prec_liq, sens_prec_sol
-    REAL, DIMENSION(klon), INTENT(IN)       :: lat_prec_liq, lat_prec_sol
 
 ! Local variables
@@ -592,6 +583,4 @@
        cpl_tauy(1:knon,cpl_index) = 0.0
        cpl_windsp(1:knon,cpl_index) = 0.0
-       cpl_sens_rain(1:knon,cpl_index) = 0.0
-       cpl_sens_snow(1:knon,cpl_index) = 0.0
        cpl_taumod(1:knon,cpl_index) = 0.0
        IF (carbon_cycle_cpl) cpl_atm_co2(1:knon,cpl_index) = 0.0
@@ -625,8 +614,4 @@
        cpl_windsp(ig,cpl_index) = cpl_windsp(ig,cpl_index) + &
             windsp(ig)      / REAL(nexca)
-       cpl_sens_rain(ig,cpl_index) = cpl_sens_rain(ig,cpl_index) + &
-            sens_prec_liq(ig)      / REAL(nexca)
-       cpl_sens_snow(ig,cpl_index) = cpl_sens_snow(ig,cpl_index) + &
-            sens_prec_sol(ig)      / REAL(nexca)
        cpl_taumod(ig,cpl_index) =   cpl_taumod(ig,cpl_index) + &
           SQRT ( taux(ig)*taux(ig)+tauy(ig)*tauy(ig) ) / REAL (nexca)
@@ -669,8 +654,4 @@
           sum_error = sum_error + error
           ALLOCATE(cpl_windsp2D(nbp_lon,jj_nb), stat=error)
-          sum_error = sum_error + error
-          ALLOCATE(cpl_sens_rain2D(nbp_lon,jj_nb,2), stat=error)
-          sum_error = sum_error + error
-          ALLOCATE(cpl_sens_snow2D(nbp_lon,jj_nb,2), stat=error)
           sum_error = sum_error + error
           ALLOCATE(cpl_taumod2D(nbp_lon,jj_nb,2), stat=error)
@@ -725,10 +706,4 @@
             knon, knindex)
 
-       CALL gath2cpl(cpl_sens_rain(:,cpl_index), cpl_sens_rain2D(:,:,cpl_index), &
-            knon, knindex)
-
-       CALL gath2cpl(cpl_sens_snow(:,cpl_index), cpl_sens_snow2D(:,:,cpl_index), &
-            knon, knindex)
-
        CALL gath2cpl(cpl_taumod(:,cpl_index), cpl_taumod2D(:,:,cpl_index), &
             knon, knindex)
@@ -747,6 +722,5 @@
        pctsrf, lafin, rlon, rlat, &
        swdown, lwdown, fluxlat, fluxsens, &
-       precip_rain, precip_snow, evap, tsurf, fder, albsol, taux, tauy,&
-       sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol)
+       precip_rain, precip_snow, evap, tsurf, fder, albsol, taux, tauy)
 !
 ! This subroutine cumulates some fields for each time-step during a coupling 
@@ -772,6 +746,4 @@
     REAL, DIMENSION(klon), INTENT(IN)       :: albsol, taux, tauy
     REAL, DIMENSION(klon,nbsrf), INTENT(IN) :: pctsrf
-    REAL, DIMENSION(klon), INTENT(IN)       :: sens_prec_liq, sens_prec_sol
-    REAL, DIMENSION(klon), INTENT(IN)       :: lat_prec_liq, lat_prec_sol
     LOGICAL, INTENT(IN)                     :: lafin
 
@@ -806,6 +778,4 @@
        cpl_taux(1:knon,cpl_index) = 0.0
        cpl_tauy(1:knon,cpl_index) = 0.0
-       cpl_sens_rain(1:knon,cpl_index) = 0.0
-       cpl_sens_snow(1:knon,cpl_index) = 0.0
        cpl_taumod(1:knon,cpl_index) = 0.0
     ENDIF
@@ -836,8 +806,4 @@
        cpl_tauy(ig,cpl_index) = cpl_tauy(ig,cpl_index) + &
             tauy(ig)        / REAL(nexca)     
-       cpl_sens_rain(ig,cpl_index) = cpl_sens_rain(ig,cpl_index) + &
-            sens_prec_liq(ig)      / REAL(nexca)
-       cpl_sens_snow(ig,cpl_index) = cpl_sens_snow(ig,cpl_index) + &
-            sens_prec_sol(ig)      / REAL(nexca)
        cpl_taumod(ig,cpl_index) = cpl_taumod(ig,cpl_index) + &
             SQRT ( taux(ig)*taux(ig)+tauy(ig)*tauy(ig) ) / REAL(nexca) 
@@ -873,8 +839,4 @@
           sum_error = sum_error + error
           ALLOCATE(cpl_windsp2D(nbp_lon,jj_nb), stat=error)
-          sum_error = sum_error + error
-          ALLOCATE(cpl_sens_rain2D(nbp_lon,jj_nb,2), stat=error)
-          sum_error = sum_error + error
-          ALLOCATE(cpl_sens_snow2D(nbp_lon,jj_nb,2), stat=error)
           sum_error = sum_error + error
           ALLOCATE(cpl_taumod2D(nbp_lon,jj_nb,2), stat=error)
@@ -927,10 +889,4 @@
 
        CALL gath2cpl(cpl_tauy(:,cpl_index), cpl_tauy2D(:,:,cpl_index), &
-            knon, knindex)
-
-       CALL gath2cpl(cpl_sens_rain(:,cpl_index), cpl_sens_rain2D(:,:,cpl_index), &
-            knon, knindex)
-
-       CALL gath2cpl(cpl_sens_snow(:,cpl_index), cpl_sens_snow2D(:,:,cpl_index), &
             knon, knindex)
 
@@ -1122,8 +1078,4 @@
     tab_flds(:,:,ids_nsfice) = cpl_nsol2D(:,:,2)
     tab_flds(:,:,ids_dflxdt) = cpl_fder2D(:,:,2)
-    tab_flds(:,:,ids_qraioc) = cpl_sens_rain2D(:,:,1)
-    tab_flds(:,:,ids_qsnooc) = cpl_sens_snow2D(:,:,1)
-    tab_flds(:,:,ids_qraiic) = cpl_sens_rain2D(:,:,2)
-    tab_flds(:,:,ids_qsnoic) = cpl_sens_snow2D(:,:,2)
     
     IF (version_ocean=='nemo') THEN
@@ -1327,7 +1279,4 @@
     DEALLOCATE(cpl_taux2D, cpl_tauy2D, cpl_windsp2D, cpl_taumod2D, stat=error )
     sum_error = sum_error + error
-    DEALLOCATE(cpl_sens_rain2D, cpl_sens_snow2D, stat=error)
-    sum_error = sum_error + error
-
     
     IF (carbon_cycle_cpl) THEN
Index: LMDZ5/trunk/libf/phylmd/oasis.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/oasis.F90	(revision 2541)
+++ LMDZ5/trunk/libf/phylmd/oasis.F90	(revision 2545)
@@ -55,9 +55,5 @@
   INTEGER, PARAMETER :: ids_atmco2 = 24
   INTEGER, PARAMETER :: ids_taumod = 25
-  INTEGER, PARAMETER :: ids_qraioc = 26
-  INTEGER, PARAMETER :: ids_qsnooc = 27
-  INTEGER, PARAMETER :: ids_qraiic = 28
-  INTEGER, PARAMETER :: ids_qsnoic = 29
-  INTEGER, PARAMETER :: maxsend    = 29  ! Maximum number of fields to send
+  INTEGER, PARAMETER :: maxsend    = 25  ! Maximum number of fields to send
   
   ! Id for fields received from ocean
@@ -181,8 +177,4 @@
             infosend(ids_atmco2)%action = .TRUE. ; infosend(ids_atmco2)%name = 'COATMCO2'
         ENDIF
-        infosend(ids_qraioc)%action = .TRUE. ; infosend(ids_qraioc)%name = 'COQRAIOC'
-        infosend(ids_qsnooc)%action = .TRUE. ; infosend(ids_qsnooc)%name = 'COQSNOOC'
-        infosend(ids_qraiic)%action = .TRUE. ; infosend(ids_qraiic)%name = 'COQRAIIC'
-        infosend(ids_qsnoic)%action = .TRUE. ; infosend(ids_qsnoic)%name = 'COQSNOIC'
         
     ELSE IF (version_ocean=='opa8') THEN
Index: LMDZ5/trunk/libf/phylmd/ocean_cpl_mod.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/ocean_cpl_mod.F90	(revision 2541)
+++ LMDZ5/trunk/libf/phylmd/ocean_cpl_mod.F90	(revision 2545)
@@ -191,6 +191,7 @@
     CALL cpl_send_ocean_fields(itime, knon, knindex, &
          swnet, lwnet, fluxlat, fluxsens, &
-         precip_rain, precip_snow, evap, tsurf_new, fder_new, alb1, flux_u1, flux_v1, windsp,&
-         sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol)
+         precip_rain, precip_snow, evap, tsurf_new, fder_new, alb1, flux_u1, flux_v1, windsp&
+         ) 
+!         ,sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol)
     
 
@@ -352,6 +353,7 @@
        pctsrf, lafin, rlon, rlat, &
        swnet, lwnet, fluxlat, fluxsens, &
-       precip_rain, precip_snow, evap, tsurf_new, fder_new, alb1, flux_u1, flux_v1,&
-       sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol)
+       precip_rain, precip_snow, evap, tsurf_new, fder_new, alb1, flux_u1, flux_v1 &
+       )
+!      ,sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol)
 
  